Index: lib/spatial/mapbuilder/lib/model/StyledLayerDescriptor.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/StyledLayerDescriptor.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/model/StyledLayerDescriptor.js	(revision 4307)
@@ -0,0 +1,43 @@
+ /*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: StyledLayerDescriptor.js 3947 2008-03-27 18:13:25Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
+/**
+ * Stores a SLD file  as defined by the
+ * Open Geospatial Consortium (http://www.opengeospatial.org/).
+ *
+ * @constructor
+ * @base ModelBase
+ * @author Olivier Terral
+ * @requires Sarissa
+ * @param modelNode The model's XML object node from the configuration document.
+ * @param parent    The parent model for the object.
+ */
+function StyledLayerDescriptor(modelNode, parent) {
+  // Inherit the ModelBase functions and parameters
+  ModelBase.apply(this, new Array(modelNode, parent));
+  
+  this.sld = null;
+  this.namespace = "xmlns:sld='http://www.opengis.net/sld' xmlns:mb='http://mapbuilder.sourceforge.net/mapbuilder' xmlns:wmc='http://www.opengis.net/context' xmlns:wms='http://www.opengis.net/wms' xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:ogc='http://www.opengis.net/ogc' xmlns:xlink='http://www.w3.org/1999/xlink' xmlns:wfs='http://www.opengis.net/wfs'";
+  this.sldXPath = this.getProperty("mb:sldXPath", "/sld:StyledLayerDescriptor");
+
+  this.getSldNode=function() {
+  	return this.doc.selectSingleNode(this.sldXPath);
+  }
+  
+  /**
+   * loads the sld into an OpenLayers hash representing the sld.
+   * @param objRef reference to this model.
+   */
+  this.loadSLD = function(objRef) {
+    var format = new OpenLayers.Format.SLD();
+    var sldNode = objRef.doc.selectSingleNode(objRef.sldXPath);
+    objRef.sld = format.read(new XMLSerializer().serializeToString(sldNode));
+  }
+  this.addFirstListener("loadModel", this.loadSLD, this);
+
+}
Index: lib/spatial/mapbuilder/lib/model/WpsCapabilities.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/WpsCapabilities.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/WpsCapabilities.js	(revision 4307)
@@ -1,13 +1,17 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: WpsCapabilities.js 3657 2007-11-29 09:04:26Z gjvoosten $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Stores a Web Processing service (WPS) Capabilities document as defined by the 
- * Open Geospatial Consortium (http://opengis.org).
+ * Open Geospatial Consortium (http://www.opengeospatial.org/).
  *
  * @constructor
+ * @base ModelBase
  * @author Mike Adair
  * @param modelNode   The model's XML object node from the configuration document.
  * @param parent The model object that this widget belongs to.
Index: lib/spatial/mapbuilder/lib/model/OwsCatResources.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/OwsCatResources.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/OwsCatResources.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: OwsCatResources.js 2546 2007-01-23 12:07:39Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
Index: lib/spatial/mapbuilder/lib/schemas/context.xsd
===================================================================
--- lib/spatial/mapbuilder/lib/schemas/context.xsd	(revision 4306)
+++ lib/spatial/mapbuilder/lib/schemas/context.xsd	(revision 4307)
@@ -6,7 +6,8 @@
 			 xmlns:sld="http://www.opengis.net/sld"
 			 xmlns:xlink="http://www.w3.org/1999/xlink"
 			 elementFormDefault="qualified">
-	<xs:import namespace="http://www.opengis.net/sld" schemaLocation="../../sld/1.0.0/StyledLayerDescriptor.xsd"/>
+	<xs:import namespace="http://www.opengis.net/sld" schemaLocation="http://schemas.opengis.net/sld/1.0.0/StyledLayerDescriptor.xsd"/>
+	<xs:import namespace="http://www.w3.org/1999/xlink" schemaLocation="http://schemas.opengis.net/xlink/1.0.0/xlinks.xsd"/>
 	<xs:element name="ViewContext" type="context:ViewContextType"/>
 	<xs:complexType name="ViewContextType">
 		<xs:sequence>
Index: lib/spatial/mapbuilder/lib/widget/LayerControl.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/LayerControl.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/LayerControl.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: GPL as per: http://www.gnu.org/copyleft/gpl.html
-$Id$
+$Id: LayerControl.js 3607 2007-11-16 05:06:51Z rdewit $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -24,6 +24,7 @@
    */
   this.prePaint = function(objRef) {
     if (objRef.model.featureName) {
+    
       objRef.stylesheet.setParameter("featureName", objRef.model.featureName );
       objRef.stylesheet.setParameter("hidden", objRef.model.getHidden(objRef.model.featureName).toString() );
     }
@@ -31,28 +32,92 @@
 
   /**
    * Displays a layer in a preview pane when mouse is over the table row
-   * @param layerName  the name of the layer to highlight
+   * @param layerId  the name of the layer to highlight
    */
-  this.highlightLayer = function(layerName) {
-    var layerId = this.model.id + "_" + "mainMapWidget" + "_" + layerName;
+  this.highlightLayer = function(layerId) {
+    var layer = this.model.map.mbMapPane.oLlayers[layerId].div;
     var previewImage = document.getElementById("previewImage");
-    var layer = document.getElementById(layerId);
-    if (previewImage) previewImage.src = layer.firstChild.src;
+    try {
+      if (previewImage && layer) previewImage.src = layer.firstChild.firstChild.src;
+    } catch(e) {}
   }
 
   /**
-   * not working yet
+   * Listener method to paint this widget
    * @param layerName  the name of the layer to highlight
    */
-  this.showLayerMetadata = function(layerName) {
+  this.refresh = function(objRef, layerName) {
+    objRef.paint(objRef, objRef.id);
+  }
+  
+  this.foldUnfoldGroup = function(groupName,id) {
+    // context config stuff to maintain group folding over refresh
+    var xpathExpression = "//wmc:General/wmc:Extension/wmc:GroupList/wmc:Group[@name='" + groupName + "']";
+    //var thisGroupsLayerNodes = model.doc.selectNodes(xpathExpression);
+    var thisGroupsNode = model.doc.selectSingleNode(xpathExpression);
+    var thisGroupsFoldedState = thisGroupsNode.getAttribute('folded');
+    var e =document.getElementById(id);
+    if(thisGroupsFoldedState == "1") {
+		thisGroupsNode.setAttribute("folded", "0");
+		e.value="-";
+		
+	} else {
+		thisGroupsNode.setAttribute("folded", "1");
+		e.value="+";
+	}
+	
+  }
+
+  /**
+   * not working yet
+   * @param layerId  the name of the layer to highlight
+   */
+  this.showLayerMetadata = function(layerId) {
     var metadataWidget = config.objects.layerMetadata;
-    metadataWidget.stylesheet.setParameter("featureName",layerName);
-    metadataWidget.node = document.getElementById(metadataWidget.htmlTagId);
-    metadataWidget.paint(metadataWidget);
+    if (metadataWidget) {
+      metadataWidget.stylesheet.setParameter("featureName",layerId);
+      metadataWidget.node = document.getElementById(metadataWidget.htmlTagId);
+      metadataWidget.paint(metadataWidget);
+    }
   }
+  
+  /**
+   * Change image source from imageA to imageB
+   * @param id  id of image tag where we want to change the source
+   * @param imageA   url of imageA
+   * @param imageB   url of imageB
+   */
+  this.ChangeImage= function (id, imageA, imageB) {
+     var indexA=document.getElementById(id).src.indexOf(imageA);
+     var indexB=document.getElementById(id).src.indexOf(imageB);
+     if (document.getElementById(id) != null) {
+        if (indexA != -1) { /* HACK for IE. */
+            document.getElementById(id).src=document.getElementById(id).src.substring(0,indexA)+imageB;
+        } else {
+           document.getElementById(id).src=document.getElementById(id).src.substring(0,indexB)+imageA;
+        }
+     }
+     return;
+}
 
-  this.model.addListener("deleteLayer",this.paint, this);
-  this.model.addListener("moveLayerUp",this.paint, this);
-  this.model.addListener("moveLayerDown",this.paint, this);
-  //this.model.addListener("addLayer",this.paint, this);
+/**
+   * Display or fold  the layer's legend
+   * @param id  id of legend div
+   */
+	this.switchVisibilityById = function (id) {
+	e =document.getElementById(id);
+	
+		if (e.style.display=="none") {
+			e.style.display = "block";
+		} else {
+			e.style.display = "none";
+		}
+		
+	
+     }
+  this.model.addListener("deleteLayer",this.refresh, this);
+  this.model.addListener("moveLayerUp",this.refresh, this);
+  this.model.addListener("moveLayerDown",this.refresh, this);
+  if (this.autoRefresh) this.model.addListener("addLayer",this.refresh, this);
 }
+
Index: lib/spatial/mapbuilder/lib/widget/TipWidgetOL.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/TipWidgetOL.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/TipWidgetOL.xsl	(revision 4307)
@@ -0,0 +1,2 @@
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" xmlns:topp="http://www.openplans.org/topp" version="1.0"><xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:param name="fid"/><xsl:template match="/"><div class="PopupContainer"><div class="PopupHeader">Info</div><div class="PopupContent"><xsl:apply-templates/></div></div></xsl:template><xsl:template match="wfs:FeatureCollection/gml:featureMember"><xsl:if test="*[@fid=$fid]"><table cellspacing="0" border="0"><xsl:for-each select="*/topp:*"><xsl:if test="name() != 'topp:the_geom'"><tr><td valign="top"><xsl:value-of select="name()"/></td><td><xsl:value-of select="."/></td></tr></xsl:if></xsl:for-each></table></xsl:if></xsl:template><xsl:template match="comment()|text()|processing-instruction()"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/OverviewMap.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/OverviewMap.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/OverviewMap.js	(revision 4307)
@@ -0,0 +1,184 @@
+/*
+Author:       Gertjan van Oosten gertjan at west dot nl
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: OverviewMap.js 3887 2008-02-27 18:18:53Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
+mapbuilder.loadScript(baseDir+"/widget/WidgetBase.js");
+
+/**
+ * Widget to add an OL OverviewMap to a main map.
+ * @constructor
+ * @base WidgetBase
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function OverviewMap(widgetNode, model) {
+  WidgetBase.apply(this,new Array(widgetNode, model));
+
+  var width = this.getProperty("mb:width");
+  if (width) {
+    this.width = new Number(width);
+  }
+  var height = this.getProperty("mb:height");
+  if (height) {
+    this.height = new Number(height);
+  }
+  var minRatio = this.getProperty("mb:minRatio");
+  if (minRatio) {
+    this.minRatio = new Number(minRatio);
+  }
+  var maxRatio = this.getProperty("mb:maxRatio");
+  if (maxRatio) {
+    this.maxRatio = new Number(maxRatio);
+  }
+
+  var layersNode = widgetNode.selectSingleNode("mb:layers");
+  if (layersNode) {
+    this.layerNames = new Array();
+    var layers = layersNode.childNodes;
+    for (var i = 0; i < layers.length; i++) {
+      if (layers[i].firstChild) {
+        this.layerNames.push(getNodeValue(layers[i]));
+      }
+    }
+  }
+
+  this.model.addListener("refresh", this.addOverviewMap, this);
+}
+
+/**
+ * Add an overview map to the map in this widget's model.
+ * If layers have been specified in the config, clone these layers for the
+ * overview map, otherwise just use the base layer from the main map.
+ * If any of the layers to use are WMS layers it uses an untiled version of them.
+ * @param objRef Pointer to widget object.
+ */
+OverviewMap.prototype.addOverviewMap = function(objRef) {
+  if (objRef.model && objRef.model.map) {
+    var map = objRef.model.map;
+    
+    /** reference to the OpenLayers OverviewMap control */
+    this.control = null
+
+    // Specify div and layers for overview map.
+    var options = {
+      div: objRef.getNode(),
+      objRef: this,
+      destroy: function() {
+        OpenLayers.Control.OverviewMap.prototype.destroy.apply(this, arguments);
+        this.div = null;
+        objRef.control = null;
+        objRef = null;
+      },
+      layers: new Array()
+    };
+    
+    if (objRef.minRatio) options.minRatio = objRef.minRatio;
+    if (objRef.maxRatio) options.maxRatio = objRef.maxRatio;
+
+    // Clone the base layer. This is not really the OpenLayers base layer, but
+    // the lowest layer in the Mapbuilder layers stack.
+    if (!objRef.layerNames) {
+      for (var i in map.mbMapPane.oLlayers) {
+        var oLlayer = map.mbMapPane.oLlayers[i];
+        if (oLlayer) {
+          var baseLayer = objRef.getClonedLayer(oLlayer, true);
+          options.layers.push(baseLayer);
+          break;
+        } 
+      }
+    }
+
+    // Check for specifically requested layers
+    var isBaseLayer = true;
+    if (objRef.layerNames) {
+      for (var i = 0; i < objRef.layerNames.length; i++) {
+        var oLlayer = map.mbMapPane.getLayer(map.mbMapPane, objRef.layerNames[i]);
+        if (oLlayer) {
+          options.layers.push(objRef.getClonedLayer(oLlayer, isBaseLayer));
+          isBaseLayer = false;
+        }
+      }
+    }
+    
+    // Determine size:
+    // - if width and height are both set, use these as the size;
+    // - if only width or height is set, take aspect ratio of main map into account;
+    // - otherwise, OL defaults to (180,90).
+    var extent = map.getExtent();
+    if (objRef.width && objRef.height) {
+      options.size = new OpenLayers.Size(objRef.width, objRef.height);
+    }
+    else if (objRef.width) {
+      options.size = new OpenLayers.Size(
+        objRef.width,
+        objRef.width * extent.getHeight() / extent.getWidth());
+    }
+    else if (objRef.height) {
+      options.size = new OpenLayers.Size(
+        objRef.height * extent.getWidth() / extent.getHeight(),
+        objRef.height);
+    }
+
+    // Add the overview to the main map
+    if (!objRef.control) {
+      objRef.control = new OpenLayers.Control.OverviewMap(options);
+      objRef.control.mapOptions = {theme: null};
+      map.addControl(objRef.control);
+    }
+
+    // make all layers visible
+    for (var i=0; i<options.layers.length; i++) {
+      options.layers[i].setVisibility(true);
+    }
+  }
+}
+
+/**
+ * Clone a map layer (OpenLayers.Layer subclass).
+ * If the layer is a WMS layer it returns an untiled version of it.
+ * @param layer Pointer to layer object.
+ * @param isBaseLayer {Boolean} optional parameter: should the layer become
+ * baselayer on the overview map?
+ */
+OverviewMap.prototype.getClonedLayer = function(layer, isBaseLayer) {
+  if (layer == null) {
+    return null;
+  }
+  
+  isBaseLayer = isBaseLayer ? true : false;
+
+  if (layer instanceof OpenLayers.Layer.WMS) {
+    // make an untiled wms layer, with ratio 1
+    var layerOptions = {
+      units: layer.units,
+      projection: layer.projection,
+      maxExtent: layer.maxExtent,
+      maxResolution: "auto",
+      ratio: 1,
+      singleTile: true,
+      isBaseLayer: isBaseLayer
+    };
+
+    return new OpenLayers.Layer.WMS(layer.name,
+      layer.url, {
+        layers: layer.params.LAYERS,
+        format: layer.params.FORMAT,
+        transparent: layer.params.TRANSPARENT,
+        sld: layer.params.SLD,
+        sld_body: layer.params.SLD_BODY,
+        styles: layer.params.STYLES
+      }, layerOptions);
+  }
+  else {
+    // take the layer as-is and clone it
+    var clonedLayer = layer.clone();
+    clonedLayer.setVisibility(true);
+    return clonedLayer;
+  }
+}
+  
Index: lib/spatial/mapbuilder/lib/widget/FormBase.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/FormBase.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/FormBase.js	(revision 4307)
@@ -0,0 +1,77 @@
+/*
+Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: OWSCatSearchForm.js 2076 2006-04-11 19:48:08Z madair $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Widget to display a form for input of parameters to generate a web service 
+ * request.  This JS object handles the form submit via HTTP Get by appending 
+ * a query string to the form's action URL.  The query string is created from
+ * all input elements and their values.
+ * The target model is then loaded from the URL created.
+ * A stylehseet must be specified as a property in config for this widget.  
+ * See widget/NtsForm.xsl for an example. 
+ *
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode This widget's object node from the configuration document.
+ * @param model The model that this widget is a view of.
+ */
+
+function FormBase(widgetNode, model) {
+  WidgetBaseXSL.apply(this, new Array(widgetNode, model));
+
+  //get bbox inforamtion from a map model
+  this.webServiceUrl = this.getProperty("mb:webServiceUrl");
+
+  /**
+   * Refreshes the form onblur handlers when this widget is painted.
+   * @param objRef Pointer to this CurorTrack object.
+   */
+  this.postPaint = function(objRef) {
+    var searchForm = document.getElementById(objRef.formName);
+    searchForm.parentWidget = objRef;
+    searchForm.onkeypress = objRef.handleKeyPress;
+    searchForm.onsubmit = objRef.submitForm;
+  }
+
+  //set some properties for the form output
+  this.formName = "WebServiceForm_" + mbIds.getId();
+  this.stylesheet.setParameter("formName", this.formName);
+
+  /**
+   * handles keypress events to filter out everything except "enter".  
+   * Pressing the "enter" key will trigger a form submit
+   * @param event  the event object passed in for Mozilla; IE uses window.event
+   */
+  this.handleKeyPress = function(event) {
+    var keycode;
+    var target;
+    if (event){
+      //Mozilla
+      keycode=event.which;
+      target=event.currentTarget;
+    }else{
+      //IE
+      keycode=window.event.keyCode;
+      target=window.event.srcElement.form;
+    }
+
+    if (keycode == 13) {    //enter key
+      return true;
+    }
+  }
+
+  /**
+   *
+   * @param
+   */
+  this.setValue = function(xpath, value) {
+    this.model.setXpathValue(this.model,xpath,value,false);
+  }
+}
Index: lib/spatial/mapbuilder/lib/widget/EditPolygon.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/EditPolygon.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/EditPolygon.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: EditPolygon.js 3807 2008-01-18 13:57:21Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -20,47 +20,9 @@
   // Extend EditButtonBase
   EditButtonBase.apply(this, new Array(widgetNode, model));
 
-  /**
-   * If the number of exsisting points is less than 2, append the new point to the polygon.
-   * If the number of exsisting points is equal to 2, append the new point AND the first point again.
-   * If the number of exsisting points is greater than 2, remove the last point (the first point), and append the new point AND the first point again.
-   * @param objRef      Pointer to this object.
-   * @param targetNode  The node for the enclosing HTML tag for this widget.
-   */
-  this.doAction = function(objRef, targetNode) {
-    if (objRef.enabled) {
-      var point = objRef.mouseHandler.model.extent.getXY(targetNode.evpl);
-      var old   = objRef.targetModel.getXpathValue(objRef.targetModel, objRef.featureXpath);
-      var thePolygon = "";
+  this.instantiateControl = function(objRef, Control) {
+    return new Control(objRef.featureLayer, OpenLayers.Handler.Polygon);
+  }
 
-      if (!old) {
-         thePolygon = point[0] + "," + point[1];
-      }
-      else {
-         var collect = old.split(" "); /* The string is already delimited by white space. */
-
-         if (collect.length < 2) { /* Enforce the polygon rules. */
-            thePolygon = old + " " + point[0] + "," + point[1];
-         }
-         else if (collect.length == 2) {
-            thePolygon = old + " " + point[0] + "," + point[1] + " " + collect[0];
-         }
-         else if (collect.length > 2) {
-            for (var i = 0; i < collect.length - 1; ++i) {
-
-               thePolygon = thePolygon + collect[i] + " ";
-            }
-
-            thePolygon = thePolygon + point[0] + "," + point[1] + " " + collect[0];
-         }
-      }
-
-      sucess = objRef.targetModel.setXpathValue(objRef.targetModel, objRef.featureXpath, thePolygon);
-
-      if (!sucess) {
-        alert("EditPolygon: invalid featureXpath in config: " + objRef.featureXpath);
-      }
-    }
-  }
 }
 
Index: lib/spatial/mapbuilder/lib/widget/Abstract.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Abstract.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/Abstract.js	(revision 4307)
@@ -0,0 +1,18 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: Abstract.js 2546 2007-01-23 12:07:39Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Output the context title and abstract.
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function Abstract(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+}
Index: lib/spatial/mapbuilder/lib/widget/EditButtonBase.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/EditButtonBase.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/EditButtonBase.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: EditButtonBase.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -22,16 +22,27 @@
   // cursor can be changed by specifying a new cursor in config file
   this.cursor = "crosshair"; 
 
-  this.trm=widgetNode.selectSingleNode("mb:transactionResponseModel");
-  if(this.trm)this.trm=this.trm.firstChild.nodeValue;
+  this.trm=this.getProperty("mb:transactionResponseModel");
 
   /** Empty GML to load when this tool is selected. */
-  this.defaultModelUrl=widgetNode.selectSingleNode("mb:defaultModelUrl").firstChild.nodeValue;
+  this.defaultModelUrl=this.getProperty("mb:defaultModelUrl");
 
   /** Reference to GML node to update when a feature is added. */
-  this.featureXpath=widgetNode.selectSingleNode("mb:featureXpath").firstChild.nodeValue;
+  this.featureXpath=this.getProperty("mb:featureXpath");
 
+  /** Should a new empty feature be appended after creating one? */
+  this.appendOnEdit = Mapbuilder.parseBoolean(this.getProperty("mb:appendOnEdit", true));
+
   /**
+   * OpenLayers DrawFeature control.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} class of the OL control.
+   */
+  this.createControl = function(objRef) {
+    return OpenLayers.Control.DrawFeature;
+  }
+  
+  /**
    * If tool is selected and the Edit Tool has changed (eg, changed from
    * LineEdit to PointEdit) then load new default feature.
    * This function is called when a tool is selected or deselected.
@@ -38,51 +49,134 @@
    * @param objRef Pointer to this object.
    * @param selected True when selected.
    */
-  this.doSelect = function(selected,objRef) {
-    // Model that will be populated with the WFS response.
-    if (objRef.trm && !objRef.transactionResponseModel){
-      objRef.transactionResponseModel=eval("config.objects."+objRef.trm);
+  this.doSelect = function(objRef, selected) {
+    if (objRef.control.active) {
+      // Model that will be populated with the WFS response.
+      if (objRef.trm && !objRef.transactionResponseModel){
+        objRef.transactionResponseModel=window.config.objects[objRef.trm];
+      }
+      // Remove the transactionResponseModel (and result of last transaction)
+      // when a transaction button is deselected
+      if(!selected && objRef.transactionResponseModel){
+        objRef.transactionResponseModel.setModel(objRef.transactionResponseModel,null);
+      }
+      
+      config.loadModel(objRef.targetModel.id, objRef.defaultModelUrl);
     }
-    // Load default feature.
-    if (objRef.enabled && selected && objRef.targetModel.url!=objRef.defaultModelUrl){
-      objRef.loadDefaultModel(objRef);
-    }
-    // Remove the transactionResponseModel (and result of last transaction)
-    // when a transaction button is deselected
-    if(!selected && objRef.transactionResponseModel){
-      objRef.transactionResponseModel.setModel(objRef.transactionResponseModel,null);
-    }
   }
+  
+  /**
+   * start a new editing session
+   * @param objRef reference to this widget
+   */
+  this.newSession = function(objRef) {
+    objRef.modified = false;
+  }
 
   /**
-   * Load the defaultModel into the targetModel.
+   * This is called by the OL onFeatureInsert handler. It will
+   * call the superclass's setFeature() method to handle the
+   * created feature.
+   * @param feature OpenLayers feature
    */
-  this.loadDefaultModel=function(objRef){
-    objRef.targetModel.url=objRef.defaultModelUrl;
-    // load default GML
-    var httpPayload=new Object();
-    httpPayload.url=objRef.defaultModelUrl;
-    httpPayload.method="get";
-    httpPayload.postData=null;
-    objRef.targetModel.newRequest(objRef.targetModel,httpPayload);
-   }
+  this.handleFeatureInsert = function(feature) {
+    // use the objRef reference stored by setEditingLayer()
+    var objRef = feature.layer.mbButton;
+    objRef.feature = OpenLayers.Util.extend({}, feature);
+    objRef.geometry = OpenLayers.Util.extend({}, feature.geometry);
+    
+    var previousFeatureNode = objRef.targetModel.doc.selectSingleNode("/*/*").cloneNode(true);
+
+    // add a new empty node if this is not the first feature
+    if (objRef.modified && objRef.appendOnEdit) {
+      objRef.targetModel.doc.selectSingleNode("/*").appendChild(previousFeatureNode);
+    }
+
+    objRef.setFeature(objRef);
+    objRef.modified = true;
+    
+    // destroy the feature in OL, because we do not use
+    // the OL vector layer for displaying the feature
+    feature.mbSelectStyle = null;
+    feature.destroy();
+  }
+
   /**
-   * Register for mouseup events, called after model loads.
+   * Set editing layer and register for editing events in OL,
+   * called after model loads.
    * @param objRef Pointer to this object.
    */
-  this.setMouseListener = function(objRef) {
-    if (objRef.mouseHandler) {
-      objRef.mouseHandler.model.addListener('mouseup',objRef.doAction,objRef);
+  this.setEditingLayer = function(objRef) {
+    if (!objRef.targetContext.featureLayers[objRef.id]) {
+      objRef.featureLayer = new OpenLayers.Layer.Vector(objRef.id);
+      // layer should always be visible, independent of the resolution
+      objRef.featureLayer.calculateInRange = function() {return true;};
+      // set objRef as mbButton attribute of the OL featureLayer,
+      // because we otherwise don't have it available in
+      // handleFeatureInsert()
+      objRef.featureLayer.mbButton = objRef;
+      objRef.targetContext.featureLayers[objRef.id] = objRef.featureLayer;
+      // register OL event handler
+      objRef.featureLayer.onFeatureInsert = objRef.handleFeatureInsert;
     }
   }
 
   /**
-   * Set the loadModel listener in response to init event
+   * Add a geometry to the enclosing GML model.
+   * @param objRef      Pointer to this object.
+   */
+  this.setFeature = function(objRef) {
+    if (!objRef.enabled) {
+      return;
+    }
+
+    var gml = new OpenLayers.Format.GML().write([objRef.feature]);
+    var gmlDoc = Sarissa.getDomDocument();
+    gmlDoc = (new DOMParser()).parseFromString(gml, "text/xml");
+    if (objRef.targetModel.namespace) {
+      Sarissa.setXpathNamespaces(gmlDoc, objRef.targetModel.namespace);
+    }
+    var insertPoint = objRef.featureXpath.lastIndexOf("/")+1;
+    var insertXpath = objRef.featureXpath.substring(insertPoint);
+    var insertNode = gmlDoc.selectSingleNode("//"+insertXpath);
+    if (!insertNode) {
+      insertNode = gmlDoc.selectSingleNode("//gml:featureMember/*/*");
+    }
+    var targetNode = objRef.targetModel.doc.selectSingleNode(objRef.featureXpath);
+    if (targetNode.childNodes.length > 0) {
+      targetNode.removeChild(targetNode.firstChild);
+    }
+
+    try {
+      Sarissa.copyChildNodes(insertNode, targetNode);
+    } catch(e) {
+      alert(mbGetMessage("invalidFeatureXpathEditLine", objRef.featureXpath));      
+    }
+    objRef.targetModel.setParam("refresh");
+  }
+
+  /**
+   * Create the array that will hold all OL feature layers
+   * for editing buttons. Also register event handler to
+   * create feature layers when the OL map is available.
    * @param objRef Pointer to this object.
    */
   this.initButton = function(objRef) {
-    objRef.targetModel.addListener("loadModel",objRef.setMouseListener, objRef);
+    // initialize feature layers for the context.
+    // each editing button gets its own feature layer,
+    // which is not used for displaying the features,
+    // because the transaction response model has its
+    // own feature renderer.
+    if (!objRef.targetContext.featureLayers) {
+    	// this array in the context will hold all
+    	// featureLayers used by editButton widgets
+    	objRef.targetContext.featureLayers = new Array();
+    }
+    
+    // feature layers will be created when the OL map is available
+    objRef.targetContext.addFirstListener("refresh",objRef.setEditingLayer, objRef);
+
+    objRef.targetModel.addListener("loadModel", objRef.newSession, objRef);
   }
-
   this.model.addListener("init",this.initButton, this);
 }
